//XmlDocument.h
//ߣ̫
//ͣhttp://www.cnblogs.com/hlxs/
#ifndef _XMLDOCUMENT_H_
#define _XMLDOCUMENT_H_
#include <iostream>  
using namespace std;
#include <fstream> 
#include <sstream>  
#include "XmlNode.h"
 
class XmlDocument;
class TXmlParser;

class XmlDocument:public XmlNode
{
public: 
	XmlDocument():fileName(string()),buf(NULL),head(string()){}
	
	XmlDocument(const string& fileName)
	{
		Load(fileName);
	}

	~XmlDocument()
	{
		if(buf!=NULL)
		{
			delete buf;
			buf=NULL;
		}
	}

	bool Load(FILE* file);

	bool Load(const string& _fileName) ;

	void SetHead(const string& _head)
	{
		head=_head;
	}

	string Head()
	{
		return head;
	}

private:
	string fileName;
	char* buf; 
	string head; 
};

//XML
class TXmlParser
{
public: 
	TXmlParser(){}
	TXmlParser(const char* _buf,XmlDocument* topNode):buf(_buf),doc(topNode){}
	const char* Buf() const 
	{
		return buf;
	}
	
	XmlDocument* TopNode()
	{
		return doc;
	}

	bool IsXML();

	bool Parser();
	
private:
	const char* ParseHead();
	const char* ParseContent(const char* p,XmlNode* node); 
	const char* GetAttr(const char* p,XmlNode* node);
	const char* GetNodeValue(const char* p,XmlNode* node);
	 
	inline static bool IsWhiteSpace(char c)		
	{ 
		return ( isspace((unsigned char)c) || c == '\n' || c == '\r' ); 
	}

	inline static bool IsWhiteSpace(int c)
	{
		if ( c < 256 )
			return IsWhiteSpace((char)c);
		return false;	 
	}

	//հ
	static const char*  SkipWhiteSpace(const char* c);

	//ע
	static const char*  SkipNote(const char* p,bool& isNode);

	XmlDocument* doc;
	const char* buf; 
};
  
#endif