//XmlNode.h
//ߣ̫
//ͣhttp://www.cnblogs.com/hlxs/
#ifndef _XMLNODE_H_
#define _XMLNODE_H_
#include <iostream>  
using namespace std;
#include <fstream> 
#include <sstream>  
#include <vector>
#include <queue>
#include <map> 
#include <assert.h>
#include "StringHelper.h"
class XmlNode ;
class XmlNodeList;
class XmlAttribute;

//ڵ
class XmlAttribute
{
	public :
		typedef map<string, string>::iterator Iterator; 
		XmlAttribute();
		~XmlAttribute();
		
		//
	 	void Append(const string& name,const string& value);
		 
		//õԵֵ
		string& operator[](int index);

		//ƵõԵֵ
		string operator[](const string& name) ;

		string GetValue(const string& name);

		bool Contains(const string& name);

		void Remove(const string& name);

		//Եĸ
		int Count() const;

		//һ
		Iterator begin();

		//һԵһ
		Iterator end();

	private :
		map<string, string> attrList;
		XmlAttribute& operator=(const XmlAttribute& );
		int count;  
};

  
//ӽڵ㼯
class XmlNodeList
{
	public: 
		typedef vector<XmlNode*>::iterator Iterator;
		 
		~XmlNodeList();

		void AppendNode(XmlNode* node);//ӽڵ

		XmlNode* operator[](int index);
		 
		int Count();//ӽڵ

		Iterator begin(); 
		Iterator end();

		void Clear();//ӽڵ
		//ѯڵnameΪnameĽڵ㣬ڵvect
		void SelectNode(vector<XmlNode*>& vect, const string& name);
	private:
		vector<XmlNode*> nodeList; 
};


//ڵ
class XmlNode
{
	public:
		typedef vector<XmlNode*>::iterator Iterator;
		friend class TXmlParser;
		friend class XmlNodeList;
		XmlNode():name(string()),parent(NULL){
			InitNode();
		}
		XmlNode(const string& _name):name(StringHelper::ToLower(_name)),parent(NULL){
			InitNode();
		}
		XmlNode(const string& _name,XmlNode* _parent):name(StringHelper::ToLower(_name)),parent(_parent){
			InitNode();
		} 
		virtual ~XmlNode();

		void SetAttribute(XmlAttribute* attr);
		void AppendAttr(const string& name,const string& value);// 
		XmlAttribute* Attribute() const;//ڵԼ
		int AttrCount() const;
		void AppendNode(XmlNode* node);//ӽڵ
		void InsertBefore(XmlNode* newNode,XmlNode* refNode);//ӽڵ

		XmlNode* FirstChild(); //һӽڵ
		XmlNode* LastChild();//һӽڵ 
		int ChildCount() const;//ӽڵ 
		XmlNodeList* ChildNodes() const;

		//ڵֵ
		string Value() const; 
		void SetValue(const string& _value);
		//ڵ
		string Name() const; 
		void SetName(const string& _name);
		//ڵ
		XmlNode* Parent() const;
		 
		void ShowXML(XmlNode& node) const;
		void ShowAttr()const;

		void XmlNode::SelectNodes(const string& url,vector<XmlNode*>& outList);
		XmlNode* SelectSingleNode(const string& url); 
		XmlNode* SelectSingleNodeByAttr(const string& attrName,const string& attrValue); 
		XmlNode* SelectSingleNodeByAttr(const string& attrName,const string& attrValue,XmlNode* node); 
		int Sign() const;

		bool operator==(const XmlNode& node);
		bool operator!=(const XmlNode& node); 

		Iterator begin();
		Iterator end();
	protected:
		const static char BLANK=' ';  
		XmlNode* parent; //ڵ
		XmlNodeList* childNodes; //ӽڵ
		XmlAttribute* attribute; //
		string name;//ڵ
		string value;//ڵֵ 
	private:
		void SelectNodes(vector<XmlNode*>& inVect,vector<XmlNode*>& outVect,const string& name);
		XmlNode(const XmlNode&){}
		XmlNode operator=(const XmlNode&){}
		static int SEQUENCE_SIGN; 
		void InitNode();//ʼڵ 
		int sign;//ڵǣÿڵǶһ޶ 
};

 
#endif