//XmlParser.cpp
#ifndef _XMLDOCUMENT_H_
#include "XmlDocument.h"
bool TXmlParser::IsXML()
{
	if(buf==NULL || doc==NULL)
	{
		return false;
	}
	const char* p=buf;
	int count=0;
	const char* const HEAD="<?xml";
	while(p!=NULL && count<5)
	{
		p=SkipWhiteSpace(p);
		if(p==NULL || tolower(*p++)!=HEAD[count++])
		{
			return false;
		}
	}
	return true;
}

const char* TXmlParser::ParseHead()
{
	const char* p=buf;
	int length=strlen(p);
	//XMLͷ
	while(p!=NULL && *p)
	{
		p=SkipWhiteSpace(p);
		if(*p=='>')
		{
			p++;
			if(p!=NULL && *p){ 
				p=SkipWhiteSpace(p);
				if(*p=='<')
				{ 
					doc->SetHead(string(buf,length-strlen(p)));
					break;
				}
			}
		}
		p++;
	}
	return p;
}

const char* TXmlParser::ParseContent(const char* p,XmlNode* baseNode)
{ 
	if(p==NULL || !*p) 
		return NULL; 
	if(*p=='<')//ʼһڵ
	{
		bool isNote;
		p=SkipNote(p,isNote);//ע
		if(isNote) {//ע
			ParseContent(p,baseNode); 
			return NULL;
		} 
		if(*p=='/')//ڵ
		{
			while(p!=NULL && *p && *p!='>')
			{
				p++;
			} 
			++p=SkipWhiteSpace(p);
			ParseContent(p,baseNode->parent);//½ڵ
		}else{ //ڵ  
			string name;
			while(p!=NULL && *p && *p!='>' && *p!=' ' && *p!='/')
			{
				 name.push_back(*p++); 
			}
			XmlNode* node=new XmlNode(name,baseNode);
			baseNode->AppendNode(node);

			if(*p=='>')
			{
				++p=SkipWhiteSpace(p); 
				ParseContent(p,node);//½ڵ
			}else{
				p=GetAttr(p,node);
				if(*p=='/')
				{
					while(p!=NULL && *p && *p!='<')
						p++;
					ParseContent(p,baseNode);//½ڵ
				}else{
					++p=SkipWhiteSpace(p);  
					ParseContent(p,node);//½ڵ
				}
			}  
		}
	}else{//ڵֵ 
		GetNodeValue(p,baseNode);
	} 
}

const char* TXmlParser::GetNodeValue(const char* p,XmlNode* baseNode)
{
	string value;
	while(p!=NULL && *p && *p!='<')
	{
		if(*p!=' '){
			value.push_back(*p); 
		}
		p++;
	}
	baseNode->SetValue(value);
	ParseContent(p,baseNode);//½ڵ
	return p;
}
 
const char* TXmlParser::GetAttr(const char* p,XmlNode* node)
{
	while(p!=NULL && *p && *p!='>' && *p!='/'){ 
		string name;
		while(p!=NULL && *p && *p!='=')
		{
			if(*p!=' '){
				name.push_back(*p); 
			}
			p++;
		} 
		string value;
		++p=SkipWhiteSpace(p);
		p++;
		while(p!=NULL && *p && *p!='\'' && *p!='\"')
		{
			if(*p!=' '){
				value.push_back(*p); 
			}
			p++;
		} 
		node->AppendAttr(name,value);
		++p=SkipWhiteSpace(p);
	}
	return p;
}

bool TXmlParser::Parser()
{
	if(!IsXML())
	{
		return false;
	} 
	const char* p=ParseHead(); 
	if(p!=NULL && *p)
	{
		p=ParseContent(p,doc);
	}
	return true;
}

//հ
const char* TXmlParser::SkipWhiteSpace(const char* c)
{
	if(c==NULL&& *c)
		return NULL;
	const char* p=c;
	while(p!=NULL && IsWhiteSpace(*p))
	{ 
		p++;
	}
	return p;
}

//ע
const char* TXmlParser::SkipNote(const char* p,bool& isNode)
{
	isNode=false;
	if(*p=='<')//ʼһڵ
	{
		if(*(p+1)=='!')
		{
			isNode=true;
			Mark:
			while(*p!='>')
			{
				p++;
			}
			if(*(p-1)!='-' || *(p-2)!='-')
			{
				p++;
				goto Mark;
			}
		}
	}
	++p=SkipWhiteSpace(p);
	return p;
}
 
#endif